Index: LMDZ4/trunk/libf/phylmd/phyredem.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 776)
@@ -14,4 +14,6 @@
      .           run_off_lic_0_p)
       USE dimphy
+      USE mod_grid_phy_lmdz
+      USE mod_phys_lmdz_para
       IMPLICIT none
 c======================================================================
@@ -65,35 +67,37 @@
       REAL run_off_lic_0_p(klon)
       
-      REAL rlat(klon2), rlon(klon2)
-      REAL tsol(klon2,nbsrf)
-      REAL tsoil(klon2,nsoilmx,nbsrf)
-      REAL tslab(klon2), seaice(klon2)
-      REAL qsurf(klon2,nbsrf)
-      REAL qsol(klon2)
-      REAL snow(klon2,nbsrf)
-      REAL albedo(klon2,nbsrf)
-      REAL alblw(klon2,nbsrf)
-      REAL evap(klon2,nbsrf)
-      REAL rain_fall(klon2)
-      REAL snow_fall(klon2)
-      real solsw(klon2)
-      real sollw(klon2)
-      real fder(klon2)
-      REAL radsol(klon2)
-      REAL frugs(klon2,nbsrf)
-      REAL agesno(klon2,nbsrf)
-      REAL zmea(klon2)
-      REAL zstd(klon2)
-      REAL zsig(klon2)
-      REAL zgam(klon2)
-      REAL zthe(klon2)
-      REAL zpic(klon2)
-      REAL zval(klon2)
-      REAL rugsrel(klon2)
-      REAL pctsrf(klon2, nbsrf)
-      REAL t_ancien(klon2,klev), q_ancien(klon2,klev)
-      real clwcon(klon2,klev),rnebcon(klon2,klev),ratqs(klon2,klev)
-      REAL run_off_lic_0(klon2)
-      REAL masq(klon2)
+      REAL rlat(klon_glo), rlon(klon_glo)
+      REAL tsol(klon_glo,nbsrf)
+      REAL tsoil(klon_glo,nsoilmx,nbsrf)
+      REAL tslab(klon_glo), seaice(klon_glo)
+      REAL qsurf(klon_glo,nbsrf)
+      REAL qsol(klon_glo)
+      REAL snow(klon_glo,nbsrf)
+      REAL albedo(klon_glo,nbsrf)
+      REAL alblw(klon_glo,nbsrf)
+      REAL evap(klon_glo,nbsrf)
+      REAL rain_fall(klon_glo)
+      REAL snow_fall(klon_glo)
+      real solsw(klon_glo)
+      real sollw(klon_glo)
+      real fder(klon_glo)
+      REAL radsol(klon_glo)
+      REAL frugs(klon_glo,nbsrf)
+      REAL agesno(klon_glo,nbsrf)
+      REAL zmea(klon_glo)
+      REAL zstd(klon_glo)
+      REAL zsig(klon_glo)
+      REAL zgam(klon_glo)
+      REAL zthe(klon_glo)
+      REAL zpic(klon_glo)
+      REAL zval(klon_glo)
+      REAL rugsrel(klon_glo)
+      REAL pctsrf(klon_glo, nbsrf)
+      REAL t_ancien(klon_glo,klev), q_ancien(klon_glo,klev)
+      REAL clwcon(klon_glo,klev)
+      REAL rnebcon(klon_glo,klev) 
+      REAL ratqs(klon_glo,klev)
+      REAL run_off_lic_0(klon_glo)
+      REAL masq(klon_glo)
 c
       INTEGER nid, nvarid, idim1, idim2, idim3
@@ -107,187 +111,43 @@
       CHARACTER*2 str2
 c
-      REAL,SAVE,ALLOCATABLE :: rlat_mpi(:), rlon_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: tsol_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: tsoil_mpi(:,:,:)
-      REAL,SAVE,ALLOCATABLE :: tslab_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: seaice_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: qsurf_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: qsol_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: snow_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: albedo_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: alblw_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: evap_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: rain_fall_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: snow_fall_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: solsw_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: sollw_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: fder_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: radsol_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: frugs_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: agesno_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: zmea_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: zstd_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: zsig_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: zgam_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: zthe_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: zpic_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: zval_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: rugsrel_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: pctsrf_mpi(:, :)
-      REAL,SAVE,ALLOCATABLE :: t_ancien_mpi(:,:), q_ancien_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: clwcon_mpi(:,:),rnebcon_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: ratqs_mpi(:,:)
-      REAL,SAVE,ALLOCATABLE :: run_off_lic_0_mpi(:)
-      REAL,SAVE,ALLOCATABLE :: masq_mpi(:)
+      call Gather( rlat_p,rlat)
+      call Gather( rlon_p,rlon)
+      call Gather( tsol_p,tsol)
+      call Gather( tsoil_p,tsoil)
+      call Gather( tslab_p,tslab)
+      call Gather( seaice_p,seaice)
+      call Gather( qsurf_p,qsurf)
+      call Gather( qsol_p,qsol)
+      call Gather( snow_p,snow)
+      call Gather( albedo_p,albedo)
+      call Gather( alblw_p,alblw)
+      call Gather( evap_p,evap)
+      call Gather( radsol_p,radsol)
+      call Gather( rain_fall_p,rain_fall)
+      call Gather( snow_fall_p,snow_fall)
+      call Gather( sollw_p,sollw)
+      call Gather( solsw_p,solsw)
+      call Gather( fder_p,fder)
+      call Gather( frugs_p,frugs)
+      call Gather( agesno_p,agesno)
+      call Gather( zmea_p,zmea)
+      call Gather( zstd_p,zstd)
+      call Gather( zsig_p,zsig)
+      call Gather( zgam_p,zgam)
+      call Gather( zthe_p,zthe)
+      call Gather( zpic_p,zpic)
+      call Gather( zval_p,zval)
+      call Gather( rugsrel_p,rugsrel)
+      call Gather( pctsrf_p,pctsrf)
+      call Gather( run_off_lic_0_p,run_off_lic_0)
+      call Gather( t_ancien_p,t_ancien)
+      call Gather( q_ancien_p,q_ancien)
+      call Gather( rnebcon_p,rnebcon)
+      call Gather( clwcon_p,clwcon)
+      call Gather( ratqs_p,ratqs)
+      call Gather( zmasq,masq)
       
 c$OMP MASTER
-      ALLOCATE( rlat_mpi(klon_mpi), rlon_mpi(klon_mpi))
-      ALLOCATE( tsol_mpi(klon_mpi,nbsrf))
-      ALLOCATE( tsoil_mpi(klon_mpi,nsoilmx,nbsrf))
-      ALLOCATE( tslab_mpi(klon_mpi))
-      ALLOCATE( seaice_mpi(klon_mpi))
-      ALLOCATE( qsurf_mpi(klon_mpi,nbsrf))
-      ALLOCATE( qsol_mpi(klon_mpi))
-      ALLOCATE( snow_mpi(klon_mpi,nbsrf))
-      ALLOCATE( albedo_mpi(klon_mpi,nbsrf))
-      ALLOCATE( alblw_mpi(klon_mpi,nbsrf))
-      ALLOCATE( evap_mpi(klon_mpi,nbsrf))
-      ALLOCATE( rain_fall_mpi(klon_mpi))
-      ALLOCATE( snow_fall_mpi(klon_mpi))
-      ALLOCATE( solsw_mpi(klon_mpi))
-      ALLOCATE( sollw_mpi(klon_mpi))
-      ALLOCATE( fder_mpi(klon_mpi))
-      ALLOCATE( radsol_mpi(klon_mpi))
-      ALLOCATE( frugs_mpi(klon_mpi,nbsrf))
-      ALLOCATE( agesno_mpi(klon_mpi,nbsrf))
-      ALLOCATE( zmea_mpi(klon_mpi))
-      ALLOCATE( zstd_mpi(klon_mpi))
-      ALLOCATE( zsig_mpi(klon_mpi))
-      ALLOCATE( zgam_mpi(klon_mpi))
-      ALLOCATE( zthe_mpi(klon_mpi))
-      ALLOCATE( zpic_mpi(klon_mpi))
-      ALLOCATE( zval_mpi(klon_mpi))
-      ALLOCATE( rugsrel_mpi(klon_mpi))
-      ALLOCATE( pctsrf_mpi(klon_mpi, nbsrf))
-      ALLOCATE( t_ancien_mpi(klon_mpi,klev))
-      ALLOCATE( q_ancien_mpi(klon_mpi,klev))
-      ALLOCATE( clwcon_mpi(klon_mpi,klev),rnebcon_mpi(klon_mpi,klev))
-      ALLOCATE( ratqs_mpi(klon_mpi,klev))
-      ALLOCATE( run_off_lic_0_mpi(klon_mpi))
-      ALLOCATE( masq_mpi(klon_mpi))
-c$OMP END MASTER
-c$OMP BARRIER      
-
-      call GatherField_omp( rlat_p,rlat_mpi,1)
-      call GatherField_omp( rlon_p,rlon_mpi,1)
-      call GatherField_omp( tsol_p,tsol_mpi,nbsrf)
-      call GatherField_omp( tsoil_p,tsoil_mpi,nsoilmx*nbsrf)
-      call GatherField_omp( tslab_p,tslab_mpi,1)
-      call GatherField_omp( seaice_p,seaice_mpi,1)
-      call GatherField_omp( qsurf_p,qsurf_mpi,nbsrf)
-      call GatherField_omp( qsol_p,qsol_mpi,1)
-      call GatherField_omp( snow_p,snow_mpi,nbsrf)
-      call GatherField_omp( albedo_p,albedo_mpi,nbsrf)
-      call GatherField_omp( alblw_p,alblw_mpi,nbsrf)
-      call GatherField_omp( evap_p,evap_mpi,nbsrf)
-      call GatherField_omp( radsol_p,radsol_mpi,1)
-      call GatherField_omp( rain_fall_p,rain_fall_mpi,1)
-      call GatherField_omp( snow_fall_p,snow_fall_mpi,1)
-      call GatherField_omp( sollw_p,sollw_mpi,1)
-      call GatherField_omp( solsw_p,solsw_mpi,1)
-      call GatherField_omp( fder_p,fder_mpi,1)
-      call GatherField_omp( frugs_p,frugs_mpi,nbsrf)
-      call GatherField_omp( agesno_p,agesno_mpi,nbsrf)
-      call GatherField_omp( zmea_p,zmea_mpi,1)
-      call GatherField_omp( zstd_p,zstd_mpi,1)
-      call GatherField_omp( zsig_p,zsig_mpi,1)
-      call GatherField_omp( zgam_p,zgam_mpi,1)
-      call GatherField_omp( zthe_p,zthe_mpi,1)
-      call GatherField_omp( zpic_p,zpic_mpi,1)
-      call GatherField_omp( zval_p,zval_mpi,1)
-      call GatherField_omp( rugsrel_p,rugsrel_mpi,1)
-      call GatherField_omp( pctsrf_p,pctsrf_mpi, nbsrf)
-      call GatherField_omp( run_off_lic_0_p,run_off_lic_0_mpi,1)
-      call GatherField_omp( t_ancien_p,t_ancien_mpi,klev)
-      call GatherField_omp( q_ancien_p,q_ancien_mpi,klev)
-      call GatherField_omp( rnebcon_p,rnebcon_mpi,klev)
-      call GatherField_omp( clwcon_p,clwcon_mpi,klev)
-      call GatherField_omp( ratqs_p,ratqs_mpi,klev)
-      call GatherField_omp( zmasq,masq_mpi,1)
-
-c$OMP MASTER      
-      call GatherField( rlat_mpi,rlat,1)
-      call GatherField( rlon_mpi,rlon,1)
-      call GatherField( tsol_mpi,tsol,nbsrf)
-      call GatherField( tsoil_mpi,tsoil,nsoilmx*nbsrf)
-      call GatherField( tslab_mpi,tslab,1)
-      call GatherField( seaice_mpi,seaice,1)
-      call GatherField( qsurf_mpi,qsurf,nbsrf)
-      call GatherField( qsol_mpi,qsol,1)
-      call GatherField( snow_mpi,snow,nbsrf)
-      call GatherField( albedo_mpi,albedo,nbsrf)
-      call GatherField( alblw_mpi,alblw,nbsrf)
-      call GatherField( evap_mpi,evap,nbsrf)
-      call GatherField( radsol_mpi,radsol,1)
-      call GatherField( rain_fall_mpi,rain_fall,1)
-      call GatherField( snow_fall_mpi,snow_fall,1)
-      call GatherField( sollw_mpi,sollw,1)
-      call GatherField( solsw_mpi,solsw,1)
-      call GatherField( fder_mpi,fder,1)
-      call GatherField( frugs_mpi,frugs,nbsrf)
-      call GatherField( agesno_mpi,agesno,nbsrf)
-      call GatherField( zmea_mpi,zmea,1)
-      call GatherField( zstd_mpi,zstd,1)
-      call GatherField( zsig_mpi,zsig,1)
-      call GatherField( zgam_mpi,zgam,1)
-      call GatherField( zthe_mpi,zthe,1)
-      call GatherField( zpic_mpi,zpic,1)
-      call GatherField( zval_mpi,zval,1)
-      call GatherField( rugsrel_mpi,rugsrel,1)
-      call GatherField( pctsrf_mpi,pctsrf, nbsrf)
-      call GatherField( run_off_lic_0_mpi,run_off_lic_0,1)
-      call GatherField( t_ancien_mpi,t_ancien,klev)
-      call GatherField( q_ancien_mpi,q_ancien,klev)
-      call GatherField( rnebcon_mpi,rnebcon,klev)
-      call GatherField( clwcon_mpi,clwcon,klev)
-      call GatherField( ratqs_mpi,ratqs,klev)
-      call GatherField( masq_mpi,masq,1)
-      
-      DEALLOCATE( rlat_mpi, rlon_mpi)
-      DEALLOCATE( tsol_mpi)
-      DEALLOCATE( tsoil_mpi)
-      DEALLOCATE( tslab_mpi)
-      DEALLOCATE( seaice_mpi)
-      DEALLOCATE( qsurf_mpi)
-      DEALLOCATE( qsol_mpi)
-      DEALLOCATE( snow_mpi)
-      DEALLOCATE( albedo_mpi)
-      DEALLOCATE( alblw_mpi)
-      DEALLOCATE( evap_mpi)
-      DEALLOCATE( rain_fall_mpi)
-      DEALLOCATE( snow_fall_mpi)
-      DEALLOCATE( solsw_mpi)
-      DEALLOCATE( sollw_mpi)
-      DEALLOCATE( fder_mpi)
-      DEALLOCATE( radsol_mpi)
-      DEALLOCATE( frugs_mpi)
-      DEALLOCATE( agesno_mpi)
-      DEALLOCATE( zmea_mpi)
-      DEALLOCATE( zstd_mpi)
-      DEALLOCATE( zsig_mpi)
-      DEALLOCATE( zgam_mpi)
-      DEALLOCATE( zthe_mpi)
-      DEALLOCATE( zpic_mpi)
-      DEALLOCATE( zval_mpi)
-      DEALLOCATE( rugsrel_mpi)
-      DEALLOCATE( pctsrf_mpi)
-      DEALLOCATE( t_ancien_mpi)
-      DEALLOCATE( q_ancien_mpi)
-      DEALLOCATE( clwcon_mpi,rnebcon_mpi)
-      DEALLOCATE( ratqs_mpi)
-      DEALLOCATE( run_off_lic_0_mpi)
-      DEALLOCATE( masq_mpi)
-
-      if (phy_rank==0) then
+      IF (is_mpi_root) THEN
       
       ierr = NF_CREATE(fichnom, NF_CLOBBER, nid)
@@ -302,6 +162,6 @@
 c
       ierr = NF_DEF_DIM (nid, "index", length, idim1)
-      ierr = NF_DEF_DIM (nid, "points_physiques", klon2, idim2)
-      ierr = NF_DEF_DIM (nid, "horizon_vertical", klon2*klev, idim3)
+      ierr = NF_DEF_DIM (nid, "points_physiques", klon_glo, idim2)
+      ierr = NF_DEF_DIM (nid, "horizon_vertical", klon_glo*klev, idim3)
 c
       ierr = NF_ENDDEF(nid)
@@ -402,7 +262,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf(1 : klon2, is_ter))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf(1 : klon2, is_ter))
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf(1 : klon_glo, is_ter))
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf(1 : klon_glo, is_ter))
 #endif
 C 
@@ -419,7 +279,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf(1 : klon2,is_lic))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf(1 : klon2, is_lic))
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf(1 : klon_glo,is_lic))
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf(1 : klon_glo, is_lic))
 #endif
 C
@@ -436,7 +296,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf(1 : klon2, is_oce))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf(1 : klon2, is_oce))
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf(1 : klon_glo, is_oce))
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf(1 : klon_glo, is_oce))
 #endif
 C
@@ -453,7 +313,7 @@
       ierr = NF_ENDDEF(nid)
 #ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf(1 : klon2, is_sic))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf(1 : klon2, is_sic))
+      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf(1 : klon_glo, is_sic))
+#else
+      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf(1 : klon_glo, is_sic))
 #endif
 C
@@ -767,5 +627,5 @@
 cc ----> necessaire pour eviter bug openMP sur SX6
 c$OMP MASTER
-      if (phy_rank==0) then
+      if (is_mpi_root) then
       DO nsrf = 1, nbsrf
         IF (nsrf.LE.99) THEN
@@ -1020,5 +880,5 @@
       ierr = NF_CLOSE(nid)
 c
-      endif   ! phy_rank==0
+      endif   ! is_mpi_root
 c$OMP END MASTER
       RETURN
Index: LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/physiq.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/physiq.F	(revision 776)
@@ -21,4 +21,6 @@
       USE write_field_phy
       USE dimphy
+      USE mod_grid_phy_lmdz
+      USE mod_phys_lmdz_para
       USE iophy
       USE misc_mod, mydebug=>debug
@@ -68,6 +70,8 @@
 c d_q_dyn-input-R-tendance dynamique pour "q" (kg/kg/s)
 c omega---input-R-vitesse verticale en Pa/s
+cIM comgeomphy.h BEG
 c cuphy----input-R-resolution des mailles en x (m)
 c cvphy----input-R-resolution des mailles en y (m)
+cIM comgeomphy.h END
 c d_u-----output-R-tendance physique de "u" (m/s/s)
 c d_v-----output-R-tendance physique de "v" (m/s/s)
@@ -75,4 +79,5 @@
 c d_qx----output-R-tendance physique de "qx" (kg/kg/s)
 c d_ps----output-R-tendance physique de la pression au sol
+cIM
 c PVteta--output-R-vorticite potentielle a des thetas constantes
 c======================================================================
@@ -440,5 +445,5 @@
       INTEGER ncolmx, seed(klon,napisccp)
       REAL nbsunlit(nregISCtot,klon,napisccp)  !nbsunlit : moyenne de sunlit
-      PARAMETER(ncolmx=1500)
+      PARAMETER(ncolmx=350)
 c
 cIM verif boxptop BEG
@@ -1415,5 +1420,5 @@
 c Declaration des constantes et des fonctions thermodynamiques
 c
-      REAL Field_tmp(klon2,klevp1)
+      REAL Field_tmp(klon_glo,klevp1)
       LOGICAL,SAVE :: first=.true.
 c$OMP THREADPRIVATE(first)
@@ -3299,5 +3304,5 @@
 cIM calcul composantes axiales du moment angulaire et couple des montagnes
 c
-      IF (monocpu) THEN
+      IF (is_sequential) THEN
       
         CALL aaam_bud (27,klon,klev,rjourvrai,gmtime,
Index: LMDZ4/trunk/libf/phylmd/phytrac.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/phytrac.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/phytrac.F	(revision 776)
@@ -64,4 +64,6 @@
       USE ioipsl
       USE dimphy
+      USE mod_grid_phy_lmdz
+      USE mod_phys_lmdz_para
       USE comgeomphy
       USE iophy
@@ -211,6 +213,5 @@
 c$OMP THREADPRIVATE(trs)
 cym      SAVE trs
-      REAL :: trs_tmp(klon2)
-      REAL,SAVE,ALLOCATABLE :: trs_mpi(:)
+      REAL :: trs_tmp(klon_glo)
       
       REAL,save,allocatable :: masktr(:,:) ! Masque reservoir de sol traceur
@@ -403,7 +404,4 @@
          if (debutphy) then
            allocate( trs(klon,nbtr) )
-c$OMP MASTER
-	   allocate( trs_mpi(klon_mpi) )  
-c$OMP END MASTER           
 	   allocate( masktr(klon,nbtr)) 
            allocate( fshtr(klon,nbtr) )
@@ -447,14 +445,14 @@
          trs(:,:) = 0.
 c$OMP MASTER         
-       if (phy_rank==0) then
+       if (is_mpi_root) then
          trs_tmp(:)=0.
 	 open (99,file='starttrac',status='old',
      .         err=999,form='formatted')
-         read(99,*) (trs_tmp(i),i=1,klon2)
+         read(99,*) (trs_tmp(i),i=1,klon_glo)
 999      close(99)
        endif
-       call ScatterField(trs_tmp,trs_mpi,1)
 c$OMP END MASTER
-      call ScatterField_omp(trs_mpi,trs(:,1),1)
+       call Scatter(trs_tmp,trs(:,1))
+
 c         print*, 'apres starttrac'
 
@@ -923,11 +921,10 @@
       if (lafin) then
          print*, 'c est la fin de la physique'
-	 call GatherField_omp(trs(:,1),trs_mpi,1)
+	 call Gather(trs(:,1),trs_tmp)
 c$OMP MASTER	 
-	 call GatherField(trs_mpi,trs_tmp,1)
-	 if (phy_rank==0) then
+	 if (is_mpi_root) then
          
 	   open (99,file='restarttrac',  form='formatted')
-           do i=1,klon
+           do i=1,klon_glo
                write(99,*) trs_tmp(i)
            enddo
Index: LMDZ4/trunk/libf/phylmd/readsulfate.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/readsulfate.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/readsulfate.F	(revision 776)
@@ -3,5 +3,7 @@
 !
       SUBROUTINE readsulfate (r_day, first, sulfate_p)
-      USE dimphy, klon=>klon2,klon2=>klon
+      USE dimphy, ONLY : klev
+      USE mod_grid_phy_lmdz, klon=>klon_glo
+      USE mod_phys_lmdz_para
       IMPLICIT none
       
@@ -84,10 +86,9 @@
         allocate( so4(klon, klev, 12) )
         allocate( so4_out(klon, klev))
-        allocate(sulfate_mpi(klon_mpi,klev))  
         first2=.false.
 	
       endif
 
-      if (phy_rank==0) then
+      if (is_mpi_root) then
             
       iday = INT(r_day) 
@@ -288,8 +289,6 @@
       endif   ! phy_rank==0
       
-      call ScatterField(real(sulfate),real(sulfate_mpi),klev)
 c$OMP END MASTER
-      call ScatterField_omp(real(sulfate_mpi),real(sulfate_p)
-     . ,klev)            
+      call Scatter(real(sulfate),real(sulfate_p))            
 
       RETURN
@@ -305,5 +304,7 @@
       
       SUBROUTINE readsulfate_preind (r_day, first, pi_sulfate_p)
-      USE dimphy, klon=>klon2,klon2=>klon
+      USE dimphy, ONLY : klev
+      USE mod_grid_phy_lmdz, klon=>klon_glo
+      USE mod_phys_lmdz_para
       IMPLICIT none
       
@@ -347,5 +348,4 @@
       REAL*8  pi_sulfate (klon, klev)  ! Number conc. sulfate (monthly mean data, 
                                   !  from fil
-      REAL*8,SAVE,ALLOCATABLE :: pi_sulfate_mpi(:,:)			  
 c      
 c Local Variables:
@@ -377,10 +377,9 @@
         allocate( pi_so4(klon, klev, 12) )
         allocate( pi_so4_out(klon, klev))
-        allocate(pi_sulfate_mpi (klon_mpi, klev))  
         first2=.false.
 	
       endif
 
-      if (phy_rank==0) then
+      if (is_mpi_root) then
     
       
@@ -528,10 +527,8 @@
       ENDIF ! Was this the beginning of a new day?
 
-      endif   ! phy_rank==0
-      
-      call ScatterField(real(pi_sulfate),real(pi_sulfate_mpi),klev)
+      endif   ! is_mpi_root==0
+      
 c$OMP END MASTER
-      call ScatterField_omp(real(pi_sulfate_mpi),real(pi_sulfate_p)
-     .,klev)            
+      call Scatter(real(pi_sulfate),real(pi_sulfate_p))            
 
       RETURN
Index: LMDZ4/trunk/libf/phylmd/soil.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/soil.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/soil.F	(revision 776)
@@ -4,5 +4,6 @@
       SUBROUTINE soil(ptimestep, indice, knon, snow, ptsrf, ptsoil,
      s          pcapcal, pfluxgrd)
-      use dimphy
+      USE dimphy
+      USE mod_phys_lmdz_para
       IMPLICIT NONE
 
@@ -73,4 +74,5 @@
       REAL zdz2(nsoilmx),z1(klon,nbsrf)
       REAL,SAVE :: min_period,dalph_soil
+c$OMP THREADPRIVATE( min_period,dalph_soil)     
       REAL ztherm_i(klon)
 
@@ -151,4 +153,5 @@
          dalph_soil=2.    ! rapport entre les epaisseurs de 2 couches succ.
 c$OMP MASTER
+         IF (is_mpi_root) THEN
          OPEN(99,file='soil.def',status='old',form='formatted',err=9999)
          READ(99,*) min_period
@@ -159,6 +162,8 @@
          CLOSE(99)
 9999     CONTINUE
+         ENDIF  ! is_mpi_root
 c$OMP END MASTER
-c$OMP BARRIER
+         CALL bcast(min_period)
+	 CALL bcast(dalph_soil)
 
 c   la premiere couche represente un dixieme de cycle diurne
Index: LMDZ4/trunk/libf/phylmd/tetalevel.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/tetalevel.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/tetalevel.F	(revision 776)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
 c================================================================
 c================================================================
Index: LMDZ4/trunk/libf/phylmd/thermcell.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/thermcell.F	(revision 776)
@@ -1,2 +1,6 @@
+!
+! $Header$
+!
+
       SUBROUTINE thermcell(ngrid,nlay,ptimestep
      s                  ,pplay,pplev,pphi
Index: LMDZ4/trunk/libf/phylmd/thermcell.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/thermcell.h	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/thermcell.h	(revision 776)
@@ -1,2 +1,6 @@
+!
+! $Header$
+!
+
       integer iflag_thermals,nsplit_thermals
       real r_aspect_thermals,l_mix_thermals,tho_thermals
Index: LMDZ4/trunk/libf/phylmd/transp_lay.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/transp_lay.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/transp_lay.F	(revision 776)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
       SUBROUTINE transp_lay (paprs,tsol,
      e                   t, q, u, v, geom,
Index: LMDZ4/trunk/libf/phylmd/undefSTD.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/undefSTD.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/undefSTD.F	(revision 776)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
       SUBROUTINE undefSTD(nlevSTD,itap,tlevSTD,
      $           dtime,ecrit_hf,
Index: LMDZ4/trunk/libf/phylmd/wrgradsfi.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/wrgradsfi.F	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/wrgradsfi.F	(revision 776)
@@ -3,5 +3,7 @@
 !
       subroutine wrgradsfi(if,nl,fieldfi_p,name,titlevar)
-      use dimphy
+      USE dimphy
+      USE mod_grid_phy_lmdz
+      USE mod_phys_lmdz_para
       implicit none
 
@@ -14,5 +16,5 @@
       integer if,nl
       real fieldfi_p(klon,nl)
-      real fieldfi(klon2,nl)
+      real fieldfi(klon_glo,nl)
       real fielddyn((iim+1)*(jjm+1),llm)
       character*10 name
@@ -26,12 +28,15 @@
 
 c     print*,'Transformation pour ',name
-      call GatherField(fieldfi_p,fieldfi,nl)
-      
-      if (phy_rank==0) then
+      call Gather(fieldfi_p,fieldfi)
+
+c$OMP MASTER      
+      if (is_mpi_root) then
         call gr_fi_dyn(nl,klon,iim+1,jjm+1,fieldfi,fielddyn)
+        
 c     print*,'Transformation OK '
         call wrgrads(if,nl,fielddyn,name,titlevar)
 c     print*,'Ecriture ok'
       endif
+c$OMP END MASTER
       
       return
Index: LMDZ4/trunk/libf/phylmd/write_field_phy.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/write_field_phy.F90	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/write_field_phy.F90	(revision 776)
@@ -1,2 +1,5 @@
+!
+! $Header$
+!
 MODULE write_field_phy
 
@@ -5,5 +8,8 @@
     SUBROUTINE WriteField_phy(name,Field,ll)
     USE dimphy
+    USE mod_phys_lmdz_para
+    USE mod_grid_phy_lmdz
     USE Write_Field
+    
     IMPLICIT NONE
     include 'dimensions90.h'
@@ -14,24 +20,15 @@
     real, dimension(klon_omp,ll) :: Field
     real,save,allocatable :: Field_tmp(:,:)
-    real, dimension(klon2,ll):: New_Field
+    real, dimension(klon_glo,ll):: New_Field
     real, dimension(iim,jjp1,ll):: Field_2d
-	
-    if (omp_rank==0) then
-      allocate(Field_tmp(klon_mpi,ll))
-    endif
-    
-!$OMP BARRIER
-    CALL GatherField_omp(Field,Field_tmp,ll)
-!$OMP BARRIER
 
-  if (omp_rank==0) then
-    CALL GatherField(Field_tmp,New_Field,ll)
-    IF (phy_rank==0) THEN
-      CALL gr_fi_ecrit(ll, klon2,iim,jjp1, New_Field, Field_2d)
+    CALL Gather(Field,New_Field)
+!$OMP MASTER
+    IF (is_mpi_root) THEN	
+      CALL Grid1Dto2D_glo(New_Field,Field_2D)
       CALL WriteField(name,Field_2d)
     ENDIF
-    deallocate(Field_tmp)
-  endif
-!$OMP BARRIER 
+!$OMP END MASTER
+
   
    END SUBROUTINE WriteField_phy
Index: LMDZ4/trunk/libf/phylmd/write_histREGDYN.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/write_histREGDYN.h	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/write_histREGDYN.h	(revision 776)
@@ -4,5 +4,5 @@
       if (ok_regdyn) then
       
-      if (monocpu) then
+      if (is_sequential) then
 
 
@@ -59,5 +59,5 @@
       endif
 
-      endif ! monocpu
+      endif ! is_sequential
 
       endif
Index: LMDZ4/trunk/libf/phylmd/write_histday_seri.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/write_histday_seri.h	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/write_histday_seri.h	(revision 776)
@@ -2,4 +2,6 @@
 c $Header$
 c
+      IF (is_sequential) THEN
+      
       IF (monocpu) THEN
       
Index: LMDZ4/trunk/libf/phylmd/write_histhf.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/write_histhf.h	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/write_histhf.h	(revision 776)
@@ -329,5 +329,5 @@
       CALL histwrite_phy(nid_hf, "SWupTOA",itau_w,zx_tmp_fi2d)
 c
-      IF (monocpu) THEN
+      IF (is_sequential) THEN
 cym      CALL gr_fi_ecrit(nbteta,klon,iim,jjmp1,PVteta,zx_tmp_3dte)
       DO k=1, nbteta
Index: LMDZ4/trunk/libf/phylmd/write_paramLMDZ_phy.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/write_paramLMDZ_phy.h	(revision 775)
+++ LMDZ4/trunk/libf/phylmd/write_paramLMDZ_phy.h	(revision 776)
@@ -1,4 +1,4 @@
 c
-      IF (monocpu) THEN
+      IF (is_sequential) THEN
       
       ndex2d = 0
